open Opcodes

module StringMap = Map.Make(String)

let builtins = 
  let builtin_list = [("__neg/2", [PushInt 0; Load 0; SubOp; Store 1; PushBool 1]);
                    ("__not/1", [Load 0; NotOp]);
                    ("__mult/3", [Load 0; Load 1; MulOp; Store 2; PushBool 1]);
                    ("__div/3", [Load 0; Load 1; DivOp; Store 2; PushBool 1]);
                    ("__add/3", [Load 0; Load 1; AddOp; Store 2; PushBool 1]);
                    ("__sub/3", [Load 0; Load 1; SubOp; Store 2; PushBool 1]);
                    ("__cons/3", [Load 0; Load 1; ConsOp; Store 2; PushBool 1]);
                    ("__gt/2", [Load 0; Load 1; GtOp]);
                    ("__lt/2", [Load 0; Load 1; LtOp]);
                    ("__ge/2", [Load 0; Load 1; GtEqOp]);
                    ("__le/2", [Load 0; Load 1; LtEqOp]);
                    ("__eq/2", [Load 0; Load 1; EqOp]);
                    ("__ne/2", [Load 0; Load 1; NeOp]);
                    ("__print/1", [Load 0; BuiltIn(1);]);
                    ("__write/1", [Load 0; BuiltIn(2);]);
                    ("__exit/1", [Load 0; Halt]); (* TODO: respect exit code *)
                    ("__exit/0", [PushInt 0; Halt]);
                    ("__true/1", [Load 0; BuiltIn(3)]);
                    ("__true/0", [PushBool(1)]);
                    ("__false/0", [PushBool(0)]);
                    ("__integer/1", [Load 0; TestInt]);
                    ("__string/1", [Load 0; TestString]);
                    ("__boolean/1", [Load 0; TestBool]);
                    ("__atom/1", [Load 0; TestAtom]);
                    ("__list/1", [Load 0; TestList]);
                    ("__tointeger/2", [Load 0; BuiltIn(4); Store 1; PushBool 1]);
                    ("__tostring/2", [Load 0; BuiltIn(5); Store 1; PushBool 1])]
in
List.fold_left (fun m (n,c) -> StringMap.add n c m) StringMap.empty builtin_list

